// /////////////////////////////////////////////////////////////////////////
// AMS code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef HIF_GLOBALS_HH
#define HIF_GLOBALS_HH

#include <systemc>

extern double analogTime;

double _system_abstime();

struct AnalogPair{
    double pot;
    double flw;

    AnalogPair():
        pot(0.0),
        flw(0.0)
    {}

    AnalogPair( const double pot_0, const double flw_0 ):
        pot(pot_0),
        flw(flw_0)
    {}

    ~AnalogPair()
    {}

    bool operator == (const AnalogPair & other) const
    {
        if (pot != other.pot) return false;
        if (flw != other.flw) return false;
        return true;
    }

    friend std::ostream & operator << (std::ostream & out, const AnalogPair & other
        )
    {
        out << other.pot;
        out << other.flw;
        return out;
    }

    friend void sc_trace(sc_core::sc_trace_file *tf, const AnalogPair & other, const
         std::string & name)
    {
        using namespace sc_core;
        sc_trace(tf, other.pot, name + ".pot");
        sc_trace(tf, other.flw, name + ".flw");
    }
};


#endif

